<template>
  <el-form
    :label-position="'right'"
    label-width="120px"
    :model="systemForm"
    :rules="formRules"
    ref="systemRef"
    style="max-width: 66%"
  >
    <el-form-item label="所属机构" prop="organization_id">
      <el-tree-select v-model="systemForm.organization_id" :data="orgData" :props="treeProps" :render-after-expand="false" :disabled="formType" style="width: 100%;"/>
    </el-form-item>
    <el-form-item label="业务系统编码" prop="business_code">
      <el-input v-model="systemForm.business_code" :disabled="formType"/>
    </el-form-item>
    <el-form-item label="业务系统名称" prop="business_name">
      <el-input v-model="systemForm.business_name" />
    </el-form-item>
    <el-form-item label="AppId" prop="appid" v-if="formType">
      <el-input v-model="systemForm.appid" :disabled="formType" style="width: 80%;"/>
      <span class="pl-1"><el-button type="primary" @click="copyText(systemForm.appid)">复制</el-button></span>
    </el-form-item>
    <el-form-item label="AppSecret" prop="appsecret" v-if="formType">
      <el-input v-model="systemForm.appsecret" :disabled="formType" style="width: 80%;"/>
      <span class="pl-1"><el-button type="primary" @click="copyText(systemForm.appsecret)">复制</el-button></span>
      <span class="pl-1"><el-button type="primary">重置</el-button></span>
    </el-form-item>
    <el-form-item label="系统LOGO" prop="logo">
       <bg-upload-image v-model="systemForm.logo" :showTips="true" :limit="1" :fileSize="500" :fileSizeUnit="'KB'" listType="picture-card" :accept="['.jpg','.jpeg','.png']" customTips="请选择图片上传：大小120 * 120像素支持jpg、png等格式，图片需小于500KB"></bg-upload-image>
    </el-form-item>
     <el-form-item label="业务系统概述" prop="business_desc">
      <el-input type="textarea" :rows="3" v-model="systemForm.business_desc" />
    </el-form-item>
     <el-form-item label="角色" prop="system_role_id" v-if="!formType">
      <el-input v-model="systemForm.system_role_id" />
    </el-form-item>
     <el-form-item label="账号" prop="system_account">
      <el-input v-model="systemForm.system_account" />
    </el-form-item>
     <el-form-item label="密码" prop="password" v-if="!formType">
      <el-input :type="password_eye ? 'text' : 'password'" v-model="systemForm.password" >
        <template #suffix>
          <bg-icon @click="password_eye = !password_eye" class="icon_eye"  icon="#bg-ic-eye"></bg-icon>
        </template>
      </el-input>
    </el-form-item>
     <el-form-item label="确认密码" prop="confirm_password" v-if="!formType">
      <el-input :type="confirm_eye ? 'text' : 'password'" v-model="systemForm.confirm_password" >
        <template #suffix>
            <bg-icon @click="confirm_eye = !confirm_eye" class="icon_eye"  icon="#bg-ic-eye"></bg-icon>
        </template>
      </el-input>
    </el-form-item>
     <el-form-item label="访问地址" prop="access_address">
      <el-input v-model="systemForm.access_address" />
    </el-form-item>
    <el-form-item label="开发厂商名称" prop="develop_id">
      <el-input v-model="systemForm.develop_id" />
    </el-form-item>
    <el-form-item label="是否启用" prop="state">
      <bg-switch :labels="['否','是']" :values="[0,1]" v-model="systemForm.state"></bg-switch>
    </el-form-item>
  </el-form>
</template>

<script setup>
import { reactive, ref, onBeforeMount, onMounted, getCurrentInstance, computed } from 'vue'
const { proxy } = getCurrentInstance()
const { $axios,$message } = proxy
const props = defineProps({
  formType: {
    type: Boolean,
    default: false, //false 新建 true 编辑
  },
  id: {
    type: String,
    default: '', 
  }
});
const systemForm = reactive({
  organization_id: '',
  business_code: '',
  business_name: '',
  business_desc: '',
  logo: [],
  system_role_id: '',
  system_account: '',
  password: '',
  confirm_password: '',
  access_address: '',
  develop_id: '',
  state: 1,
  appid: '',
  appsecret: ''
})
const password_eye = ref(false)
const confirm_eye = ref(false);

const validatePass = (rule, value, callback) => {
  if (value !== systemForm.password) {
    callback(new Error("密码输入不一致"))
  } else {
    callback()
  }
}
const validateBusinessName = (rule, value, callback) => {
  let params = null;
   if (props.id){
     params = {id: parseInt(props.id),business_name: value,organization_id: systemForm.organization_id}
   }else {
     params = {business_name: value,organization_id: systemForm.organization_id}
   }

  $axios.post(`/apaas/system/v5/user/check/business`,params)
     .then((res) => {
      if (res.data.code == 200) {
            callback()
      }else {
          callback(new Error(res.data.data))
      }
     })
}

const validateSystemAccount = (rule, value, callback) => {
  let params = null;
   if (props.id){
     params = {id: parseInt(props.id),system_account: value,}
   }else {
     params = {system_account: value}
   }

  $axios.post(`/apaas/system/v5/user/check/account`,params)
     .then((res) => {
      if (res.data.code == 200) {
            callback()
      }else {
          callback(new Error(res.data.data))
      }
     })
}

const formRules = reactive({
  organization_id: [
    { required: true, message: '请选择组织机构', trigger: 'blur' },
  ],
  business_name: [
    { required: true, message: '请输入业务系统名称', trigger: 'blur' },
    { validator: validateBusinessName, trigger: 'blur' },
  ],
  system_role_id: [
    { required: true, message: '请选择角色', trigger: 'blur' },
  ],
  system_account: [
    { required: true, message: '请输入账号', trigger: 'blur' },
    { validator: validateSystemAccount, trigger: 'blur' },
  ],
  password: [
    { required: true, message: '请输入密码', trigger: 'blur' },
    {min: 8,message: '密码长度不得低于8位',trigger: 'blur'}
  ],
  confirm_password: [
    { required: true, message: '请确认密码', trigger: 'blur' },
    { validator: validatePass, trigger: 'blur' }
  ],
})



const systemRef = ref(null)
const emit = defineEmits(['action'])

const submitForm = async () => {
  if (!systemRef) return
  await systemRef.value.validate((valid, fields) => {
    if (valid) {
      emit('action', systemForm)
    } else {
      emit('action',null)
    }
  })
}

const clearForm = () => {
  if (!systemRef) return
  systemRef.value.resetFields()
} 

const setForm = (data) => {
  systemForm.value = Object.assign(systemForm, data);
}

const orgData = ref([])
const treeProps = {
  label: 'name',
  children: 'Child',
  value: 'organization_id'
}
const getOrgTree = () => {
  $axios.get(`/apaas/system/v5/org/tree`)
     .then((res) => {
     if (res.data.code == 200) {
         orgData.value = res.data.data || [];
     }else {
         $message.error(res.data.msg)
     }
     })
}

const copyText = (data) => {
  navigator.clipboard.writeText(data).then(
        function () {
          
        },
        function () {
          
        }
      );
}

onBeforeMount(() =>{
  getOrgTree()
})

onMounted(() => {

})


defineExpose({ submitForm, clearForm, setForm })
</script>